unit UntChat;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, ExtCtrls, ShellApi;

type
  TChatFal = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    Quadro: TMemo;
    C_Comandos: TGroupBox;
    C_Texto: TEdit;
    S_Cliente: TClientSocket;
    S_Server: TServerSocket;
    Status: TMemo;
    GroupBox2: TGroupBox;
    Host: TEdit;
    Servidor: TLabel;
    Apelido: TEdit;
    Apedlido: TLabel;
    Conectar: TButton;
    Servir: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure C_TextoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ConectarClick(Sender: TObject);
    procedure S_ClienteConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure S_ClienteDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure S_ClienteError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure S_ClienteRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServirClick(Sender: TObject);
    procedure S_ServerListen(Sender: TObject; Socket: TCustomWinSocket);
    procedure S_ServerClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure S_ServerClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure S_ServerClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Label2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ChatFal: TChatFal;

implementation

{$R *.dfm}

procedure TChatFal.FormCreate(Sender: TObject);
begin
Quadro.Text := '';
end;

procedure TChatFal.C_TextoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
If Key = VK_Return Then
  Begin
    S_Cliente.Socket.SendText(C_Texto.Text + '::::' + Apelido.Text);
    C_Texto.Text := '';
End;

end;

procedure TChatFal.ConectarClick(Sender: TObject);
begin
If S_Cliente.Active Then
  Begin
    S_Cliente.Active := False;
    Conectar.Caption := 'Conectar';
End
      Else
        Begin
          S_Cliente.Host := Host.Text;
          S_Cliente.Active := True;
      End;
end;

procedure TChatFal.S_ClienteConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
begin
Status.Lines.Add('Cliente ::> Conectado a: ' + S_Cliente.Host);
Conectar.Caption := 'Desconectar';
Apelido.Enabled := False;
S_Cliente.Socket.SendText('NICK::::' + Apelido.Text);
end;
end;

procedure TChatFal.S_ClienteDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Status.Lines.Add('Cliente ::> Desconectado ');
Conectar.Caption := 'Conectar';
Apelido.Enabled := True;
end;

procedure TChatFal.S_ClienteError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
Status.Lines.Add('Cliente ::> ERRO ao tentar conectar a: ' + S_Cliente.Host);
end;

procedure TChatFal.S_ClienteRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Quadro.Lines.Add(Socket.ReceiveText);
end;

procedure TChatFal.ServirClick(Sender: TObject);
begin
If S_Server.Active = True Then
  Begin
    S_Server.Active := False;
    Status.Lines.Add('Servidor ::> Servidor Desligado!');
    Servir.Caption := 'Iniciar Servidor';
    S_Cliente.Active := False;
    Host.Enabled := True;
    Conectar.Enabled := True;
End
      Else
        Begin
          S_Server.Active := True;
          Servir.Caption := 'Parar Servidor';
          Host.Enabled := False;
          Conectar.Enabled := False;
          S_Cliente.Host := '127.0.0.1';
          S_Cliente.Active := True;
      End;


end;

procedure TChatFal.S_ServerListen(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Status.Lines.Add('Servidor ::> Servidor Ligado!');
end;

procedure TChatFal.S_ServerClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Status.Lines.Add('Servidor ::> Usurio Conectado => '+ Socket.RemoteAddress);
end;

procedure TChatFal.S_ServerClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Status.Lines.Add('Servidor ::> Usurio Desconectado => '+ Socket.RemoteAddress);

end;

procedure TChatFal.S_ServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
Var
  Texto: array[0..1] Of String;
  Temptexto: String;
  Index: integer;
Begin
Temptexto := Socket.ReceiveText;
Texto[0] := Copy(Temptexto, 1,Pos('::::', Temptexto) -1);
Texto[1] := Copy(Temptexto, Pos('::::', Temptexto) + Length('::::'),Length(temptexto));
If Texto[0] = 'NICK' Then
    Begin
      With S_Server.Socket Do Begin
      For Index := 0 To ActiveConnections-1 Do Begin
      Connections[Index].SendText(texto[1] + ' entrou na sala: ');
end;
end;
end
        Else
          Begin
            With S_Server.Socket Do Begin
            For Index := 0 To ActiveConnections-1 Do Begin
            Connections[Index].SendText('(' + texto[1] + ')' +' escreveu: ' + Texto[0]);
        end;
        end;
        Status.Lines.Add('Servidor ::> ' + Texto[1] + ' (' + Socket.RemoteAddress + ')'+ 'escreveu: '+ Texto[0]);
end;
end;

procedure TChatFal.Label2Click(Sender: TObject);
begin
ShellExecute(GetDesktopWindow,'open',pchar('http://www.scsoftware.weebly.com'),nil,nil,sw_ShowNormal);
end;

end.
